//
// lZp[T[Ƃ̃C^[tF[X
//
//	Chihiro.SAKAMOTO
//
#include <iostream>
#include <algorithm>
#include "calc-driver.h"
#include "parser.h"

// RXgN^

calc_driver::calc_driver()
{
}

// fXgN^

calc_driver::~calc_driver()
{
}

// vZ

bool calc_driver::calc(const std::string &f)
{
	cparser parser;								// p[T[\z
	int result = parser.parse(this, f);			// \

	if (result != 0)
		return false;							// p[T[G[
	return true;
}

// G[bZ[Wo

void calc_driver::error(const std::string& m)
{
	std::cerr << m << std::endl;
}

// 

void calc_driver::assign(const std::string &value, cnode *node)
{
	values[value] = node->expr(this);
}

// print

void calc_driver::print(cnode *node)
{
	std::cout << node->expr(this) << std::endl;
}

// ϐXg̈ꗗ\

struct list_action {
	void operator()(const std::pair<std::string, int> &it)
	{
		std::cout << it.first << " = " << it.second << std::endl;
	}
} ;

void calc_driver::list()
{
	std::for_each(values.begin(), values.end(), list_action());
}
