//
// CPU
//
//	switch-caseǤμ
//
//		(c)2008 Chihiro.SAKAMOTO HyperWorks
//
#include <exception>
#include "vm.h"

// ¹
int vm::vcpu::run()
{
	command_ = data_.command_;						// ץǼ
	text_buffer_ = data_.text_buffer_;				// ƥȥǡǼ
	command_size_ = data_.command_size_;			// ץ礭
	text_size_ = data_.text_size_;					// ǡ礭

	global_value.resize(data_.value_size_);			// ѿơ֥
	command_ptr_ = command_ + data_.entry_point_;	// ץ५󥿡

	// maincall
	push(0);										// mainؤΰȤpush
	push(0);										// stack_baseνͤpush
	push(0);										// ץཪλ֤push
	stack_base = stack.size();						// åȰֽ

	try {
		int op;
		while ((op = *command_ptr_++) != VM_HALT) {	// Haltޤǥ롼
			switch (op) {
				#define	VM_SWITCHTABLE
				#include "vm_code.h"
				#undef	VM_SWITCHTABLE
			}
		}
	}
	catch (const std::exception &e) {
		std::cerr << "㳰ȯ" << e.what() << "" << std::endl;
		return -1;
	}
	return top().i_;								// mainؿ
}
