#include <boost/spirit.hpp>
#include <iostream>
#include <string>
#include <cassert>

using namespace std;
using namespace boost::spirit;

// ϥǡѤΥƥ졼
// ѹǽʤ褦typedefƤ
typedef file_iterator<>	iterator_t;

// 顼ѤΥѡʴؿ֥ȡ
struct error_parser {
	typedef nil_t result_t;		// ѡη̷nil_t

	error_parser(char const *msg)
		: msg_(msg)
	{
	}

	template <typename ScannerT>
	int operator()(ScannerT const &scan, result_t &result) const
	{
		// ޤ褿-1֤
		if (scan.at_end()) {
			return -1;
		}

		cout << msg_ << endl;
		// ᤷĹפ֤ȡʬåפΤ
		// ԤޤǤ򥹥󤷡ʬ򥹥å
		return (int)(*(anychar_p - '\n') >> ch_p('\n')).parse(scan).length();
	}

  private:
	const char *msg_;
} ;

// 顼ѤΥѡ
typedef functor_parser<error_parser> error_p;

// ʸˡ顼ѡ
error_p syntax_error_p = error_parser("ʸˡ顼");

// ʸˡ
struct calc_grammer: public grammar<calc_grammer> {
	template <typename ScannerT>
	struct definition {
		rule<ScannerT>	identifier;
		rule<ScannerT>	number;
		rule<ScannerT>	prime;
		rule<ScannerT>	unary;
		rule<ScannerT>	mul_expr;
		rule<ScannerT>	add_expr;
		rule<ScannerT>	assign;
		rule<ScannerT>	print;
		rule<ScannerT>	list;
		rule<ScannerT>	statement;
		rule<ScannerT>	input;

		// ʸˡ롼
		definition(calc_grammer const& self)
		{
			// ̻ҡѿ̾
			identifier = lexeme_d[(alpha_p | '_') >> *(alnum_p | '_')];
			// 
			number = uint_p;

			// ǽΡǤΡ
			prime	= identifier
					| number
					| '(' >> add_expr >> ')'
					;

			// ñ黻
			unary	= prime
					| '-' >> prime
					;

			// 
			mul_expr = unary >> *('*' >> unary | '/' >> unary);

			// ø
			add_expr = mul_expr >> *('+' >> mul_expr | '-' >> mul_expr);

			// ʸ
			assign = identifier >> '=' >> add_expr >> ch_p('\n');
			// printޥ
			print = str_p("print") >> add_expr >> ch_p('\n');
			// listޥ
			list = str_p("list") >> ch_p('\n');

			// ʸ
			statement	= assign
						| print
						| list
						;

			// Ϥȥޥå뤹٤ƤΥ롼
			//  | ԤΤߡʶʸ | ʸˡ顼
			input = *(statement
					| ch_p('\n')
					| syntax_error_p);
		}

		// ȥ롼
		rule<ScannerT> const& start() const
		{
			return input;
		}
	};
} ;

// main

int main(int argc, char *argv[])
{
	// եɤ߹ߤˡfile_iteratorѤ
	file_iterator<> first("input.txt");
	if (!first) {
		cout << "ե뤬ץǤޤ" << endl;
		return 1;
	}
	file_iterator<> last = first.make_end();

	// ϽԤ
	// åץѡϡ' ', '\t', '\r'򥹥åפ
	// \nϡʸѤ뤿˥åפʤ
	calc_grammer	gr;
	if (parse(first, last, gr, ch_p(' ') | ch_p('\t') | ch_p('\r')).full) {
		// 
		cout << "ʸϽλ" << endl;
	}
	else {
		// 顼äƤΤǡ顼Ȥˤʤ
		// 顼ѡǡ顼Ԥä鼺ԤȤۤ
		// ɤ
		cout << "ʸϼ" << endl;
	}

	return 0;
}
