#include <boost/spirit.hpp>
#include <iostream>
#include <string>
#include <cassert>

using namespace std;
using namespace boost::spirit;

// ̓f[^p̃Ce[^
// ύX\Ȃ悤typedefĂ
typedef file_iterator<>	iterator_t;

// G[p̃p[T[i֐IuWFNgj
struct error_parser {
	typedef nil_t result_t;		// p[T[̌ʌ^inil_tj

	error_parser(char const *msg)
		: msg_(msg)
	{
	}

	template <typename ScannerT>
	int operator()(ScannerT const &scan, result_t &result) const
	{
		// I܂ŗ-1Ԃ
		if (scan.at_end()) {
			return -1;
		}

		cout << msg_ << endl;
		// ߂uvԂƁA̕XLbv̂
		// s܂łXLA̕XLbv
		return (int)(*(anychar_p - '\n') >> ch_p('\n')).parse(scan).length();
	}

  private:
	const char *msg_;
} ;

// G[p̃p[T[`
typedef functor_parser<error_parser> error_p;

// @G[p[T[`
error_p syntax_error_p = error_parser("@G[");

// @`
struct calc_grammer: public grammar<calc_grammer> {
	template <typename ScannerT>
	struct definition {
		rule<ScannerT>	identifier;
		rule<ScannerT>	number;
		rule<ScannerT>	prime;
		rule<ScannerT>	unary;
		rule<ScannerT>	mul_expr;
		rule<ScannerT>	add_expr;
		rule<ScannerT>	assign;
		rule<ScannerT>	print;
		rule<ScannerT>	list;
		rule<ScannerT>	statement;
		rule<ScannerT>	input;

		// @[̒`
		definition(calc_grammer const& self)
		{
			// ʎqiϐj
			identifier = lexeme_d[(alpha_p | '_') >> *(alnum_p | '_')];
			// l
			number = uint_p;

			// ŏ́if́jvf
			prime	= identifier
					| number
					| '(' >> add_expr >> ')'
					;

			// PZq
			unary	= prime
					| '-' >> prime
					;

			// 揜Z
			mul_expr = unary >> *('*' >> unary | '/' >> unary);

			// Z
			add_expr = mul_expr >> *('+' >> mul_expr | '-' >> mul_expr);

			// 
			assign = identifier >> '=' >> add_expr >> ch_p('\n');
			// printR}h
			print = str_p("print") >> add_expr >> ch_p('\n');
			// listR}h
			list = str_p("list") >> ch_p('\n');

			// 
			statement	= assign
						| print
						| list
						;

			// ͂ƃ}b`邷ׂẴ[
			//  | ŝ݁i󕶁j | @G[
			input = *(statement
					| ch_p('\n')
					| syntax_error_p);
		}

		// X^[g[̒`
		rule<ScannerT> const& start() const
		{
			return input;
		}
	};
} ;

// main

int main(int argc, char *argv[])
{
	// t@C̓ǂݍ݂ɁAfile_iteratorgp
	file_iterator<> first("input.txt");
	if (!first) {
		cout << "t@CI[vł܂B" << endl;
		return 1;
	}
	file_iterator<> last = first.make_end();

	// ͏s
	// XLbvp[T[́A' ', '\t', '\r'XLbv
	// \ńiɗp邽߁jXLbvȂ
	calc_grammer	gr;
	if (parse(first, last, gr, ch_p(' ') | ch_p('\t') | ch_p('\r')).full) {
		// ͐
		cout << "\͏I" << endl;
	}
	else {
		// G[Ă̂ŁAG[Ƃɂ͗Ȃ
		// G[p[T[ŁAG[s玸sƂق
		// ǂB
		cout << "\͎s" << endl;
	}

	return 0;
}
