#include <iostream>
#include <iomanip>
#include "calc-driver.h"
#include "calc-parser.hh"

// 󥹥ȥ饯

calc_driver::calc_driver()
{
}

// ǥȥ饯

calc_driver::~calc_driver()
{
}

// ׻

bool calc_driver::calc(const std::string &f)
{
	file = f;
	scan_begin();								// ʡ
	yy::calc_parser parser(*this);				// ѡ
	int result = parser.parse();				// ʸ
	scan_end();									// ʡλ

	if (result != 0)
		return false;							// ѡ顼
	return true;
}

// 顼å

void calc_driver::error(const std::string& m)
{
	std::cerr << m << std::endl;
}

// 

void calc_driver::assign(const std::string *value, cnode *node)
{
	values[*value] = node->expr(this);
	delete value;		// ϼʬǹԤ
	delete node;
}

void calc_driver::print(cnode *node)
{
	std::cout << node->expr(this) << std::endl;
	delete node;
}

struct list_action {
	void operator()(const std::pair<std::string, int> &it)
	{
		std::cout << it.first << " = " << it.second << std::endl;
	}
} ;

void calc_driver::list()
{
	std::for_each(values.begin(), values.end(), list_action());
}
