#include <iostream>
#include <iomanip>
#include "calc-driver.h"
#include "calc-parser.hh"

// RXgN^

calc_driver::calc_driver()
{
}

// fXgN^

calc_driver::~calc_driver()
{
}

// vZ

bool calc_driver::calc(const std::string &f)
{
	file = f;
	scan_begin();								// XLi[
	yy::calc_parser parser(*this);				// p[T[\z
	int result = parser.parse();				// \
	scan_end();									// XLi[I

	if (result != 0)
		return false;							// p[T[G[
	return true;
}

// G[bZ[Wo

void calc_driver::error(const std::string& m)
{
	std::cerr << m << std::endl;
}

// 

void calc_driver::assign(const std::string *value, cnode *node)
{
	values[*value] = node->expr(this);
	delete value;		// n͎ōs
	delete node;
}

// print

void calc_driver::print(cnode *node)
{
	std::cout << node->expr(this) << std::endl;
	delete node;
}

// list

struct list_action {
	void operator()(const std::pair<std::string, int> &it)
	{
		std::cout << it.first << " = " << it.second << std::endl;
	}
} ;

void calc_driver::list()
{
	std::for_each(values.begin(), values.end(), list_action());
}
