//
// zCPU
//
//	switch-caseł̎
//
//		(c)2008 Chihiro.SAKAMOTO HyperWorks
//
#include <exception>
#include "vm.h"

// s
int vm::vcpu::internal_call(data &program, int entry, int *arg, int narg)
{
	if (program.entry_point_[entry] < 0)		// Gg[|Cg
		return 0;

	command_ = program.command_;					// vOi[ʒu
	text_buffer_ = program.text_buffer_;			// eLXgf[^i[ʒu
	command_size_ = program.command_size_;			// vȎ傫
	text_size_ = program.text_size_;				// f[^̑傫

	global_value.resize(program.value_size_);		// Oϐe[um
	command_ptr_ = command_ + program.entry_point_[entry];	// vOJE^[

	// XNvgcall
	for (int i=0; i<narg; i++) {
		push(arg[i]);								// push
	}
	push(narg);										// JEgpush
	push(0);										// stack_basȅlpush
	push(0);										// vOIʒupush
	stack_base = stack.size();						// X^bNQƈʒu

	try {
		int op;
		while ((op = *command_ptr_++) != VM_HALT) {	// Halt܂Ń[v
			switch (op) {
				#define	VM_SWITCHTABLE
				#include "vm_code.h"
				#undef	VM_SWITCHTABLE
			}
		}
	}
	catch (const std::exception &e) {
		std::cerr << "Oi" << e.what() << "j" << std::endl;
		return -1;
	}
	if (stack.empty()) {	// void^֐
		return 0;
	}

	int result = top().i_;								// ֐߂l
	pop();
	return result;
}
